var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from "react";
import _ from "lodash";
import classNames from "classnames";
import { CoreComponent, getCorePropTypes, getCorePropDefaults, getValidProps, ROLE } from "../../lib";
import "./Drawer.css";

var Drawer = (_temp = _class = function (_CoreComponent) {
  _inherits(Drawer, _CoreComponent);

  function Drawer() {
    _classCallCheck(this, Drawer);

    return _possibleConstructorReturn(this, _CoreComponent.apply(this, arguments));
  }

  Drawer.prototype.render = function render() {
    var _classes,
        _this2 = this;

    var _getValidProps = getValidProps(this.props),
        Component = _getValidProps.renderAs,
        uiclass = _getValidProps.uiclass,
        active = _getValidProps.active,
        color = _getValidProps.color,
        colorStyle = _getValidProps.colorStyle,
        uuid = _getValidProps.uuid,
        attach = _getValidProps.attach,
        icon = _getValidProps.icon,
        disabled = _getValidProps.disabled,
        minimizable = _getValidProps.minimizable,
        children = _getValidProps.children,
        props = _getValidProps.props;

    var classes = (_classes = {}, _classes["ui-drawer-" + attach] = attach, _classes.active = active, _classes.minimized = !active && minimizable, _classes);
    if (!_.isNil(color)) {
      var nohover = String(color).indexOf("!") !== -1;
      var cleanColor = String(color).replace("!", "");
      var colorClass = "ui-" + cleanColor;
      if (!_.isNil(colorStyle)) {
        colorClass += "-" + colorStyle;
      }
      if (nohover) {
        colorClass += "-no-hover";
      }
      classes[colorClass] = true;
    }

    return React.createElement(
      Component,
      _extends({}, props, { className: classNames("ui-drawer", classes) }),
      React.createElement(
        "div",
        { className: "ui-drawer-content" },
        React.Children.map(children, function (child) {
          return React.createElement(
            "div",
            { className: "ui-drawer-row" },
            _this2.renderChild(child, {
              disabled: disabled,
              uiclass: uiclass,
              active: active
            })
          );
        })
      )
    );
  };

  return Drawer;
}(CoreComponent), _class.propTypes = getCorePropTypes({
  minimizable: "bool",
  defaultOpen: "bool",
  icon: "string"
}), _class.defaultProps = getCorePropDefaults({
  uirole: ROLE.DRAWER,
  minimizable: true,
  defaultOpen: false,
  icon: "fa fa-bars",
  attach: "left"
}), _temp);


export default Drawer;