"use strict";

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _classnames = require("classnames");

var _classnames2 = _interopRequireDefault(_classnames);

var _lib = require("../../lib");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MainDrawer = (_temp = _class = function (_CoreComponent) {
  _inherits(MainDrawer, _CoreComponent);

  function MainDrawer(props) {
    _classCallCheck(this, MainDrawer);

    var _this = _possibleConstructorReturn(this, _CoreComponent.call(this, props));

    _this.onToggleHandler = function (e) {
      e.preventDefault();
      var drawerActive = _this.state.drawerActive;

      _this.setState({ drawerActive: !drawerActive });
    };

    _this.state = {
      drawerActive: false
    };
    return _this;
  }

  MainDrawer.prototype.render = function render() {
    var _this2 = this;

    var _getValidProps = (0, _lib.getValidProps)(this.props),
        Component = _getValidProps.renderAs,
        uiclass = _getValidProps.uiclass,
        icon = _getValidProps.icon,
        className = _getValidProps.className,
        disabled = _getValidProps.disabled,
        minimizable = _getValidProps.minimizable,
        children = _getValidProps.children,
        props = _getValidProps.props;

    var active = this.state.drawerActive;
    var classes = {
      active: active,
      minimized: !active && minimizable
    };

    var toggle = [];
    if (minimizable) {
      toggle.push(_react2.default.createElement(
        "div",
        { key: "main_drawer_toggle", className: "ui-main-drawer-toggle" },
        _react2.default.createElement("button", {
          className: "ui-main-drawer-toggle-button " + icon,
          onClick: this.onToggleHandler
        })
      ));
    }

    return _react2.default.createElement(
      Component,
      _extends({}, props, { className: (0, _classnames2.default)(className, classes) }),
      toggle,
      _react2.default.Children.map(children, function (child) {
        return _this2.renderChild(child, {
          disabled: disabled,
          uiclass: uiclass,
          active: active
        });
      })
    );
  };

  return MainDrawer;
}(_lib.CoreComponent), _class.propTypes = (0, _lib.getCorePropTypes)({
  minimizable: "bool",
  defaultOpen: "bool",
  icon: "string"
}), _class.defaultProps = (0, _lib.getCorePropDefaults)({
  uirole: _lib.ROLE.DRAWER,
  minimizable: true,
  defaultOpen: false,
  icon: "fa fa-bars"
}), _temp);
exports.default = MainDrawer;
module.exports = exports["default"];